<?php
/**
 * @Name
 * @Description
 * @Author 刘学玺
 * @Date 2023/11/24 11:49
 */

namespace App\Http\Controllers\Admin;

use App\Exceptions\ApiException;
use App\Exceptions\Code;
use App\Exceptions\Message;
use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\LoginRequest;
use App\Http\Services\Admin\AuthService;
use Tymon\JWTAuth\Exceptions\JWTException;
use Tymon\JWTAuth\Exceptions\TokenBlacklistedException;
use Tymon\JWTAuth\Exceptions\TokenExpiredException;
use Tymon\JWTAuth\Exceptions\TokenInvalidException;

class AuthController extends Controller
{
    public function store(LoginRequest $request)
    {
        $data = $request->only(['username', 'password']);
        return (new AuthService())->login(['name' => $data['username'], 'password' => $data['password']]);
    }

    public function menus()
    {
        return (new AuthService())->menus();
    }

    public function destroy()
    {
        return (new AuthService())->logout();
    }

}
