<?php

namespace App\Http\Controllers\Admin\Channel;

use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\PageRequest;
use App\Http\Services\Admin\Channel\DistributorService;
use App\Http\Services\Admin\System\MenusService;
use Illuminate\Http\Request;

class DistributorController extends Controller
{

    public function index(PageRequest $request)
    {
        return (new DistributorService())->index($request->only(['page', 'pageSize','name','status']));
    }

    public function all()
    {
        return (new DistributorService())->all();
    }

    /**
     * 创建菜单
     * Method : Interface store
     * @param Request $request
     * @return mixed
     */
    public function store(Request $request)
    {
        return (new MenusService())->store($request->only([
            'title',
            'name',
            'type',
            'icon',
            'pid',
            'path',
            'component',
            'redirect',
            'sort',
            'status',
            'hide',
            'keep_alive'
        ]));
    }

    public function detail(Request $request)
    {

        $id = $request->route('id');
        return (new MenusService())->detail($id);
    }

    public function update(Request $request)
    {
        return (new MenusService())->update($request->only([
            'id',
            'title',
            'name',
            'type',
            'icon',
            'pid',
            'path',
            'component',
            'redirect',
            'sort',
            'status',
            'hide',
            'keep_alive'
        ]));
    }

}
