<?php

namespace App\Http\Controllers\Admin\Order;

use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\CommonIdRequest;
use App\Http\Requests\Admin\PageRequest;
use App\Http\Services\Admin\Order\IndexService;
use App\Http\Services\Admin\OrderService;
use Illuminate\Http\Request;

class IndexController extends Controller
{
    //
    public function index(PageRequest $request)
    {
        return (new IndexService())->index($request->only([
            'page',
            'pageSize',
            'order_sn',
            'key',
            'status',
            'created_at',
            'updated_at'
        ]));
    }
    
    public function start(CommonIdRequest $request)
    {
        return (new IndexService())->start($request->only(['id']));
    }

    public function receive(CommonIdRequest $request)
    {
        return (new IndexService())->receive($request->only(['id']));
    }

    public function reset(CommonIdRequest $request)
    {
        return (new IndexService())->reset($request->only(['id']));
    }

    public function destroy(CommonIdRequest $request)
    {
        return (new IndexService())->delete($request->only(['id']));
    }

    public function grab(CommonIdRequest $request)
    {
        return (new IndexService())->grab($request->only(['id']));
    }

    public function over(CommonIdRequest $request)
    {
        return (new IndexService())->over($request->only(['id']));
    }

    public function vicinity(Request $request)
    {
        return (new IndexService())->vicinity($request->only(['id','page','pageSize']));
    }

    public function new(Request $request)
    {
        return (new IndexService())->new($request->only(['time']));
    }

    public function alarm(Request $request)
    {
        return (new IndexService())->alarm($request->only(['page','pageSize']));
    }
}
