<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\PageRequest;
use App\Http\Requests\Admin\CommonIdRequest;
use App\Http\Services\Admin\OrderService;
use Illuminate\Http\Request;

class OrderController extends Controller
{
    //
    public function index(PageRequest $request)
    {
        return (new OrderService())->index($request->only([
            'page',
            'pageSize',
            'order_sn',
            'key',
            'status',
            'created_at',
            'updated_at'
        ]));
    }

    public function reset(CommonIdRequest $request)
    {
        return (new OrderService())->reset($request->only(['id']));
    }

    public function destroy(CommonIdRequest $request)
    {
        return (new OrderService())->delete($request->only(['id']));
    }

    public function grab(CommonIdRequest $request)
    {
        return (new OrderService())->grab($request->only(['id']));
    }

    public function over(CommonIdRequest $request)
    {
        return (new OrderService())->over($request->only(['id']));
    }

    public function vicinity(Request $request)
    {
        return (new OrderService())->vicinity($request->only(['id','page','pageSize']));
    }
}
