<?php

namespace App\Http\Controllers\Admin\Project;

use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\PageRequest;
use App\Http\Requests\Admin\CommonIdRequest;
use App\Http\Services\Admin\FinanceService;
use App\Http\Services\Admin\OrderService;
use App\Http\Services\Admin\Project\CategoryService;
use App\Http\Services\Admin\Project\IndexService;
use App\Http\Services\Admin\System\MenusService;
use App\Http\Services\Admin\SystemService;
use App\Models\Project;
use Illuminate\Http\Request;

class IndexController extends Controller
{

    public function index(PageRequest $request)
    {
        return (new IndexService())->index($request->only(['page', 'pageSize', 'name', 'category','status']));
    }

    public function regionTree(Request $request)
    {
        $id = $request->route('id');
        return (new IndexService())->regionTree($id);
    }

    public function region(Request $request)
    {
        $id = $request->route('id');
        return (new IndexService())->region($id);
    }

    public function regionStore(Request $request)
    {
        return (new IndexService())->regionStore($request->only(['id', 'region_ids']));
    }

    public function regionDestroy(Request $request)
    {
        return (new IndexService())->regionDestroy($request->only(['id', 'project_id']));
    }

    public function regionUpdate(Request $request)
    {
        return (new IndexService())->regionUpdate($request->only(['id', 'minute', 'price', 'order_price']));
    }

    public function store(Request $request)
    {
        $category = $request->input('category');
        $data = $request->only(['banner', 'brief', 'content', 'icon', 'minute', 'name', 'order_price', 'price', 'is_show']);
        return (new IndexService())->store($data, $category);
    }

    public function detail(Request $request)
    {
        $id = $request->route('id');
        return (new IndexService())->detail($id);
    }

    public function update(Request $request)
    {
        $category = $request->input('category');
        $data = $request->only(['id', 'banner', 'brief', 'content', 'icon', 'minute', 'name', 'order_price', 'price', 'is_show']);
        return (new IndexService())->update($data, $category);
    }

    public function status(Request $request){
        $data = $request->only(['id','is_show']);
        return (new IndexService())->status($data);
    }

    public function destroy(Request $request)
    {
        $id = $request->route('id');
        return (new IndexService())->destroy(is_array($id) ?: [$id]);
    }
}
