<?php

namespace App\Http\Controllers\Admin\System;

use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\PageRequest;
use App\Http\Requests\Admin\CommonIdRequest;
use App\Http\Services\Admin\FinanceService;
use App\Http\Services\Admin\OrderService;
use App\Http\Services\Admin\System\MenusService;
use App\Http\Services\Admin\System\RoleService;
use App\Http\Services\Admin\SystemService;
use Illuminate\Http\Request;

class RoleController extends Controller
{
    public function index(PageRequest $request)
    {
        return (new MenusService())->index($request->only(['page', 'pageSize']));
    }

    public function store(Request $request)
    {
        return (new RoleService())->store($request->only(['id', 'ids']));
    }

    public function detail(Request $request)
    {

        $id = $request->route('id');
        return (new MenusService())->detail($id);
    }

    public function update(Request $request)
    {
        return (new MenusService())->update($request->only([
            'id',
            'title',
            'name',
            'type',
            'icon',
            'pid',
            'path',
            'component',
            'redirect',
            'sort',
            'status',
            'hide',
            'keep_alive'
        ]));
    }

}
