<?php

namespace App\Http\Controllers\Admin\User;

use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\PageRequest;
use App\Http\Requests\Admin\CommonIdRequest;
use App\Http\Services\Admin\FinanceService;
use App\Http\Services\Admin\OrderService;
use App\Http\Services\Admin\System\MenusService;
use App\Http\Services\Admin\SystemService;
use App\Http\Services\Admin\User\ArtificerService;
use App\Http\Services\Admin\User\MemberService;
use Illuminate\Http\Request;

class ArtificerController extends Controller
{

    public function index(PageRequest $request)
    {
        return (new ArtificerService())->index($request->only(['page', 'pageSize', 'key', 'phone', 'status']));
    }

    /**
     * 创建菜单
     * Method : Interface store
     * @param Request $request
     * @return mixed
     */
    public function store(Request $request)
    {
        return (new MenusService())->store($request->only([
            'title',
            'name',
            'type',
            'icon',
            'pid',
            'path',
            'component',
            'redirect',
            'sort',
            'status',
            'hide',
            'keep_alive'
        ]));
    }

    public function detail(Request $request)
    {

        $id = $request->route('id');
        return (new MenusService())->detail($id);
    }

    public function update(Request $request)
    {
        return (new MenusService())->update($request->only([
            'id',
            'title',
            'name',
            'type',
            'icon',
            'pid',
            'path',
            'component',
            'redirect',
            'sort',
            'status',
            'hide',
            'keep_alive'
        ]));
    }

    public function all()
    {
        return (new MenusService())->all();
    }

    public function audit(Request $request)
    {
        return (new ArtificerService())->audit($request->only(['id', 'status']));
    }
}
