<?php

namespace App\Http\Requests\Admin;

use Illuminate\Foundation\Http\FormRequest;

class PageRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, \Illuminate\Contracts\Validation\ValidationRule|array<mixed>|string>
     */
    public function rules(): array
    {
        return [
            'page' => 'required|integer|min:1',
            'pageSize' => 'required|integer|min:1',
        ];
    }

    public function messages(){
        return [
            'page.required' 				=> '缺少参数（page）！',
            'page.integer' 	=> '（page）参数错误！',
            'pageSize.required' 				=> '缺少参数（pageSize）！',
            'pageSize.integer' 	=> '（pageSize）参数错误！',
        ];
    }
}
