<?php
/**
 * @Name
 * @Description
 * @Author 刘学玺
 * @Date 2023/11/23 20:57
 */

namespace App\Http\Services\Admin;

use App\Http\Services\BaseService;
use App\Models\Admin;
use App\Models\Menu;
use App\Models\Role;
use App\Models\RoleAuth;
use App\Models\User;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;

class AuthService extends BaseService
{
    public function login(array $data)
    {
        try {
            $token = (new TokenService())->setToken($data);
        } catch (\Exception $e) {
            $this->apiError('用户名或密码错误');
        }
        return $this->apiSuccess('登录成功！', $token);
    }

    public function logout()
    {
        (new TokenService())->logout();
        return $this->apiSuccess('退出成功！');
    }

    public function menus()
    {
        $user = (new TokenService())->user();
        $auth_ids = RoleAuth::whereIn('role_id', $user->roles)->pluck('auth_ids')->toArray();
        $menu_ids = explode(',',join(',', $auth_ids));
//        DB::enableQueryLog();   // 启用查询日志
        $data = Menu::query()->where('status', 1)
            ->whereIn('id', $menu_ids)
            ->oldest('sort')
            ->get()
            ->toArray();
//        $query = DB::getQueryLog();  // 获取查询日志
        $menu = $this->buildMenu($data);
        return $this->apiSuccess('', $menu);
    }


}
