<?php
/**
 * @Name
 * @Description
 * @Author 刘学玺
 * @Date 2023/11/23 20:57
 */

namespace App\Http\Services\Admin\Order;

use App\Exceptions\ApiException;
use App\Http\Services\BaseService;
use App\Models\Admin;
use App\Models\Alarm;
use App\Models\Artificer;
use App\Models\ArtificerSite;
use App\Models\Order;
use App\Models\OrderGrab;
use App\Models\ProjectRelevancy;
use App\Models\User;
use Exception;
use Illuminate\Support\Facades\DB;

class AlarmService extends BaseService
{
    public function index(array $data)
    {
        $model = Alarm::query();
        $model->with(['order.project', 'order.user'=>function($query){
            $query->withTrashed();
        }, 'order.artificer']);
        $model->whereHas('order.project');
        $model->whereHas('order.artificer');
        $list = $model
            ->orderBy('id', 'desc')
            ->paginate($data['pageSize'])
            ->toArray();
        return $this->apiSuccess('', [
            'list' => $list['data'],
            'total' => $list['total']
        ]);
    }

    public function realtime(array $data)
    {
        $where['status'] = 0;
        $currentTime = time();
        $orderNumber = 0;
        if (!empty($data['time'])) {
            $time = [
                $data['time'] + 1, $currentTime
            ];
            $orderNumber = Alarm::query()->where($where)
                ->whereBetween('create_time', $time)
                ->count('id');
        }
        return $this->apiSuccess('', [
            'number' => $orderNumber,
            'time' => $currentTime
        ]);
    }
}
