<?php
/**
 * @Name
 * @Description
 * @Author 刘学玺
 * @Date 2023/11/23 20:57
 */

namespace App\Http\Services\Admin\System;

use App\Http\Services\BaseService;
use App\Models\Admin;
use App\Models\Menu;
use App\Models\User;

class MenusService extends BaseService
{
    public function index($data)
    {
        $model = $this->queryCondition(Menu::query(), $data);

        $list = $model->oldest('sort')
            ->paginate($data['pageSize'])
            ->toArray();
        return $this->apiSuccess('', [
            'list' => $list['data'],
            'total' => $list['total']
        ]);
    }

    public function store(array $data)
    {
        return $this->commonCreate(Menu::query(), $data);
    }

    public function detail($id)
    {

        $data = Menu::query()->find($id)->toArray();
        return $this->apiSuccess('', $data);
    }

    public function update(array $data)
    {
        return $this->commonUpdate(Menu::query(), $data['id'], $data);
    }

    public function all()
    {
        $list = Menu::query()->oldest('sort')
            ->select(['title','pid','id'])
            ->get()
            ->toArray();
        return $this->apiSuccess('', [
            'list' => $list
        ]);
    }

}
