<?php
/**
 * @Name
 * @Description
 * @Author 刘学玺
 * @Date 2023/11/23 20:57
 */

namespace App\Http\Services\Admin\User;

use App\Http\Services\BaseService;
use App\Models\Admin;
use App\Models\Menu;
use App\Models\User;
use Illuminate\Support\Facades\DB;

class MemberService extends BaseService
{
    public function index($data)
    {
        $model = $this->queryCondition(User::query()->where('user_type', 2), $data);
        if (!empty($data['key'])) {
            $keyWhere = [
                ['id', '=', $data['key'], 'or'],
                ['user_login', 'like', '%' . $data['key'] . '%', 'or'],
                ['user_nickname', 'like', '%' . $data['key'] . '%', 'or'],
                ['mobile', 'like', '%' . $data['key'] . '%', 'or'],
            ];
            $model->where($keyWhere);
        }
        if (!empty($data['distributor_id'])) {
            $model->where('distributor_id', $data['distributor_id']);
        }

        if (isset($data['user_status']) && $data['user_status'] !== '') {
            $model->where('user_status', $data['user_status']);
        }
        if (!empty($data['create_time']) && count($data['create_time']) === 2) {
           $model->whereBetween('create_time',[strtotime($data['create_time'][0]),strtotime($data['create_time'][1])]);
        }

        $list = $model->with(['distributor'])
            ->latest('id')
            ->paginate($data['pageSize'])
            ->toArray();

        return $this->apiSuccess('', [
            'list' => $list['data'],
            'total' => $list['total']
        ]);
    }

    public function store(array $data)
    {
        return $this->commonCreate(Menu::query(), $data);
    }

    public function detail($id)
    {

        $data = Menu::query()->find($id)->toArray();
        return $this->apiSuccess('', $data);
    }

    public function update(array $data)
    {
        return $this->commonUpdate(Menu::query(), $data['id'], $data);
    }

    public function all()
    {
        $list = Menu::query()->oldest('sort')
            ->select(['title', 'pid', 'id'])
            ->get()
            ->toArray();
        return $this->apiSuccess('', [
            'list' => $list
        ]);
    }
}
