<?php
/**
 * @Name
 * @Description
 * @Author 刘学玺
 * @Date 2023/11/23 20:57
 */

namespace App\Http\Services\Admin\Wechat;

use App\Http\Services\BaseService;
use App\Models\Admin;
use App\Models\User;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;
use Overtrue\LaravelWeChat\EasyWeChat;

class OfficialAccountService extends BaseService
{
    public function oauth(array $data)
    {
        $wechat = EasyWeChat::officialAccount();
        $oauth = $wechat->getOAuth();
        $scopes = $data['scopes'] ?: 'snsapi_base';
        // 未登录
        //callback_url 是授权回调的URL
        //生成完整的授权URL
        $redirectUrl = $oauth->scopes([$scopes])->redirect($data['redirect_url']);
        return $this->apiSuccess('', ['redirectUrl' => $redirectUrl]);

    }

    public function oauth_callback(array $data)
    {
        $wechat = EasyWeChat::officialAccount();
        $oauth = $wechat->getOAuth();
        // 获取 OAuth 授权用户信息
        $user = $oauth->userFromCode($data['code']);
        $wechat_user = $user;
        return $this->apiSuccess('', ['wechatUser' => $wechat_user]);
    }
    
    public function signature()
    {
        $wechat = EasyWeChat::officialAccount();

        $ticket = $wechat->getTicket();
        $jsapi_ticket = $ticket->getTicket();

        // 当前URL
        $url = request('url',request()->header('referer'));

        // 生成签名
        $nonceStr = 'didongdiandao'; // 请用随机算法生成
        $timestamp = time(); // 当前时间戳

        $string1 = "jsapi_ticket={$jsapi_ticket}&noncestr={$nonceStr}&timestamp={$timestamp}&url={$url}";
        $signature = sha1($string1);

        $wechatConfig = $wechat->getConfig();


        // 数据用于前端显示
        $signPackage = [
            "appId" => $wechatConfig['app_id'],
            "nonceStr" => $nonceStr,
            "timestamp" => $timestamp,
            "url" => $url,
            "signature" => $signature,
            "rawString" => $string1
        ];

        return $this->apiSuccess('', ['signPackage' => $signPackage]);
    }

}
