<?php

namespace App\Models;

use DateTimeInterface;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Order extends Model
{
    use HasFactory, SoftDeletes;

    protected $table = 'js_order';

    protected $hidden = [
        //
    ];

    public $timestamps = false;

    const DELETED_AT = 'delete_time';

    protected $dateFormat = 'U';

    protected $guarded = ['id'];

    protected $casts = [
        'create_time' => 'datetime',
        'pay_time' => 'datetime',
        'return_time' => 'datetime',
        'delete_time' => 'datetime',
//        'jiedan_time' => 'datetime',
//        'start_time' => 'datetime',
//        'finish_time' => 'datetime',

//        'password' => 'hashed',
    ];

    protected $appends = [];

    protected function serializeDate(DateTimeInterface $date): string
    {
        return $date->format('Y-m-d H:i:s');
    }

    public function project()
    {
        return $this->hasOne(Project::class, 'id', 'project_id');
    }

    public function user()
    {
        return $this->hasOne(User::class, 'id', 'user_id')->select('id', 'user_nickname', 'avatar', 'mobile');
    }

    public function artificer()
    {
        return $this->hasOne(Artificer::class, 'id', 'jiedan_js_id')->select('id', 'name', 'avatar', 'phone');
    }

    public function artificerIncome()
    {
        return $this->hasOne(UserWithdrawLog::class, 'order_sn', 'order_sn')->where('type',8)->select(['order_sn','money']);
    }

}
