<?php

namespace App\Models;

use DateTimeInterface;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class OrderGrab extends Model
{
    use HasFactory;

    protected $table = 'js_order_grab';

    protected $appends = [];

    public $timestamps = false;

    protected $casts = [
        'create_time' => 'datetime'
    ];

    public function artificer()
    {
        return $this->hasOne(Artificer::class, 'id', 'js_id')->select('id', 'name', 'avatar', 'phone', 'sex', 'is_real_time', 'is_make');
    }

    protected function serializeDate(DateTimeInterface $date): string
    {
        return $date->format('Y-m-d H:i:s');
    }
}
