<?php
/**
 * @Name
 * @Description
 * @Author 刘学玺
 * @Date 2023/12/1 18:44
 */

namespace App\Models;

use DateTimeInterface;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class UserWithdraw extends Model
{
    use HasFactory, SoftDeletes;

    protected $table = 'user_tx';

    public $timestamps = FALSE;

    const DELETED_AT = 'delete_time';

    protected $casts = [
        'create_time' => 'datetime'
    ];

    protected function serializeDate(DateTimeInterface $date): string
    {
        return $date->format('Y-m-d H:i:s');
    }

    public function user(): \Illuminate\Database\Eloquent\Relations\HasOne
    {
        return $this->hasOne(User::class, 'id', 'user_id')->select('id', 'user_type', 'user_nickname', 'avatar', 'mobile', 'balance','user_status','distributor_id');
    }

    public function admin()
    {
        return $this->hasOne(Admin::class, 'id', 'admin_id')->select('id', 'name', 'nickname');
    }
}
